# digits!

digs <- read.csv("train_digs100.csv")

# example call: plot.data
# data is a row of 784 values in the NIST digit format
plot.data <- function( data )
{
  D = 28  # image is square with D pixels on a side
  im1 <- as.single(1.0-data/255)  # adjust pixels
  im1 <- matrix( im1, nrow=D, ncol=D, byrow=T ) # make 2d
  image <- as.raster(im1)  # make a raster (an image)
  # create a plot... something
  plot(c(1,D),c(1,D), type = "n", xlab="", ylab="")
  rasterImage(image,1,1,D,D,interpolate=F)
}


# example call: plot.digit( digs, 42 )
# digs is a dataframe of digits (inc. the first two columns)
# the rownumber is exactly that...
plot.digit <- function( digs, rownumber=42 )
{
  D = 28  # image is square with D pixels on a side
  im1 <- digs[rownumber,]  # get first row
  im1 <- im1[,-c(1,2)] # remove first two columns
  plot.data(im1)
}


do_digits <- function()
{
  zeros <- digs[digs$label==0,]
  ones <-  digs[digs$label==1,]
  both <- rbind( zeros,ones )
  both <- both[,-c(1,2)]
  km <- kmeans(both,centers=2)  # works pretty well!
  hc <- hclust(dist(both))
  plot(hc)
}




