pause <- function(message="")
{
  cat( message, "<Return>")
  user <- readline("")
}

showall <- function(message,x,y,cluster.labels,cl_centers)
{
  plot(x,y,col=cluster.labels,pch=19,cex=2) 
  points(cl_centers,col=1:3,pch=3,cex=3,lwd=3) # old points
  pause(message)
}

dists <- function(df,p)
{
  diffs <- apply( df, c(1), function(row){row-p} ) # works
  m <- matrix( unlist(diffs), nrow=dim(df)[1], byrow=T ) # ludicrous
  sqdists <- apply( m*m, c(1), sum ) # square dists
  dists <- vapply( sqdists, sqrt, 42.0 )
  return(dists)
}

run_demo <- function()
{
  set.seed(1234)
  par(mar=c(0,0,0,0))
  x <- rnorm(12,mean=rep(1:3,each=4),sd=0.2)
  y <- rnorm(12,mean=rep(c(1,2,1),each=4),sd=0.2) 
  plot(x,y,col="blue",pch=19,cex=2) 
  text(x+0.05,y+0.05,labels=as.character(1:12))
  
  pause("Initial Points")
  
  
  # centers c(1,2), c(1.8,1), c(2.5,1.5)
  cl_centers = data.frame( rbind( c(1,2), c(1.8,1), c(2.5,1.5) ) )
  names(cl_centers) <- c("x","y")
  cluster.labels <- rep(c(4),12) # all blue
  showall("Starting centers",x,y,cluster.labels,cl_centers)
  
  # compute distance to each center - add as a column!
  df <- data.frame(x,y)
  
  while (TRUE)
  {
    d1 <- dists(df,cl_centers[1,])
    d2 <- dists(df,cl_centers[2,])
    d3 <- dists(df,cl_centers[3,])
    
    ddf <- data.frame(d1,d2,d3)
    old.cluster.labels <- cluster.labels
    cluster.labels <- apply( ddf, c(1), which.min )
    
    if (all(old.cluster.labels == cluster.labels))
    {
      cat("No points changed cluster... stopping\n")
      break
    }
    
    showall("Assign groups",x,y,cluster.labels,cl_centers)
    
    # need to get the new cluster centers...
    c1 <- apply( df[cluster.labels==1,], c(2), mean )
    c2 <- apply( df[cluster.labels==2,], c(2), mean )
    c3 <- apply( df[cluster.labels==3,], c(2), mean )
    
    cl_centers <- rbind( c1, c2, c3 )
    
    showall("Update centers",x,y,cluster.labels,cl_centers)
    
    # print the ss errors
  } # end of loop
}


