# kmeans - examples

# for "elbow" plot method of choosing # of centers
var_explained <- function(num_centers)
{
  km <- kmeans(iris[,-5],centers=num_centers)
  Xcol <- 1
  Xname <- names(iris)[Xcol]
  Ycol <- 3
  Yname <- names(iris)[Ycol]
  plot(iris[,Xcol],iris[,Ycol],col=km$cluster,
       xlab=Xname, ylab=Yname)
  var_expl <- km$betweenss/km$totss
  return(var_expl)
}

# demo for multiple centers...
run_ncenters_demo <- function()
{
  data(iris)
  km <- kmeans(iris[,-5],centers=3)
  Xcol <- 1
  Xname <- names(iris)[Xcol]
  Ycol <- 3
  Yname <- names(iris)[Ycol]
  #plot(iris[,Xcol],iris[,Ycol],col=km$cluster,
  #     xlab=Xname, ylab=Yname)
  
  NUM_CENTERS_TESTED <- 7
  results <- vector(mode="numeric",length=7)
  for (num_centers in 1:NUM_CENTERS_TESTED)
  {
    var_expl <- var_explained(num_centers)
    results[num_centers] <- var_expl
  }
  
  # plot variance explained for each number of centers...
  plot(1:NUM_CENTERS_TESTED, results,
       type="b",pch=16,col="black",
       xlab="number of centers",ylab="variance explained")
}

